package com.ekexiu.project.department;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;
import org.jfw.util.jdbc.JdbcUtil;
import org.jfw.util.jdbc.PreparedStatementConfig;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by TT on 2019/5/30.
 */
@Path("/department")
public class DepartmentService {

    @Autowrie
    private DepartmentDao departmentDao;

    public DepartmentDao getDepartmentDao() {
        return departmentDao;
    }

    public void setDepartmentDao(DepartmentDao departmentDao) {
        this.departmentDao = departmentDao;
    }

    @Path("/qo")
    @Get
    public Department query(@JdbcConn Connection con, String id) throws SQLException {
        return departmentDao.query(con, id);
    }

    @Path("/pq")
    @Get
    public PageQueryResult<Department> pageQuery(@JdbcConn Connection con, @Nullable Boolean active, @Nullable String name, int pageSize, int pageNo) throws SQLException {
        return departmentDao.pageQuery(con, active, name == null ? null : "%" + name + "%", pageSize, pageNo);
    }

    @Path("/hospital")
    @Get
    public PageQueryResult<Department> pqgeQuery(@JdbcConn Connection con,@Nullable Boolean active,String hospital,int pageSize,int pageNo)throws SQLException {
        return departmentDao.pageQuery(con, hospital, active, pageSize, pageNo);
    }

    @Path("/name")
    @Get
    public List<TypeaheadItem> queryName(@JdbcConn Connection con, String name, int size) throws SQLException {
        if (name != null) {
            name = "%" + name + "%";
        }
        List<TypeaheadItem> ret = new ArrayList<>(size);
        final String finalKey = name;
        List<Map<String, Object>> typehead = JdbcUtil.queryMaps(con, "SELECT NAME,ID FROM DEPARTMENT WHERE NAME LIKE ? ", new PreparedStatementConfig() {
            @Override
            public void config(PreparedStatement preparedStatement) throws SQLException {
                preparedStatement.setString(1, finalKey);
            }
        });

        for (Map<String, Object> map : typehead) {
            TypeaheadItem item = new TypeaheadItem();
            item.setId((String) map.get("id"));
            item.setName((String) map.get("name"));
            ret.add(item);
        }
        return ret;
    }


    public static class TypeaheadItem {
        private String id;
        private String name;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

    }

}
