package com.ekexiu.project.doctor;


import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/5/30.
 */
@Path("/doctor")
public class DoctorService {

    @Autowrie
    private DoctorDao doctorDao;

    public DoctorDao getDoctorDao() {
        return doctorDao;
    }

    public void setDoctorDao(DoctorDao doctorDao) {
        this.doctorDao = doctorDao;
    }


    @Get
    @Path("/qo")
    public Doctor query(@JdbcConn Connection con, String id) throws SQLException {
        return doctorDao.query(con, id);
    }

    @Get
    @Path("/pq")
    public PageQueryResult<Doctor> pageQuery(@JdbcConn Connection con, @Nullable Boolean active, @Nullable String addr, @Nullable String clinicalTitle, @Nullable String level, @Nullable String key, int pageSize, int pageNo) throws SQLException {
        return doctorDao.pageQuery(con, active, addr == null ? null : addr + "%", clinicalTitle, level, key == null ? null : "%" + key + "%", pageSize, pageNo);
    }

    @Path("/hospital")
    @Get
    public PageQueryResult<Doctor> pageQuery(@JdbcConn Connection con, @Nullable Boolean active, String hospital, int pageSize, int pageNo) throws SQLException {
        return doctorDao.pageQuery(con, hospital, active, pageSize, pageNo);
    }

    @Path("/department")
    @Get
    public PageQueryResult<Doctor> pageQuery(@JdbcConn Connection con, @Nullable Boolean active, String hospital, String department, int pageSize, int pageNo) throws SQLException {
        return doctorDao.pageQuery(con, hospital, department, active, pageSize, pageNo);
    }
}
